import java.util.Iterator;
/** We can iterate through this matrix for victory
 *  @author Josh Hug
 */

public class IterableIntMatrix implements Iterable<Integer>{
    int[][] vals;

    /** this is a bit dangerous becasue some jerk
        mioght change x so we should make our own
        copy but we don't for lack of time and it's boring */
    public IterableIntMatrix(int[][] x) {
        vals = x;
    }

    public Iterator<Integer> iterator() {
        return new IIMIterator();
    }

    private class IIMIterator implements Iterator<Integer> {
        int r;
        int c;

        public IIMIterator() {
            r = 0;
            c = 0;
        }

        public Integer next() {
            int retVal = vals[r][c];
            c = c + 1;
            if (c == vals[0].length) {
                c = 0;
                r = r + 1;
            }
            return retVal;
        }

        public boolean hasNext() {
            return (r < vals.length) && (c < vals[0].length);
        }

        public void remove() {
            throw new UnsupportedOperationException();
        }
    }

    public static void main(String[] args) {
        int[][] vals = new int[][]{{9, 15, 12, 13},
                                   {14, 19, 21, 51},
                                   {10, 4, 2, 3},
                                   {5, 3, 2, 1}};
        IterableIntMatrix iim = new IterableIntMatrix(vals);
        for (int i : iim) {
            System.out.println(i);
        }        
    }
} 